%% Script for manuscript: Modelling decadal salt marsh development: variability of the salt marsh extent under influence of waves and sediment availability? 
%% By: Pim Willemsen
%% p.willemsen@utwente.nl
%% Do not use without permission

%% Figure 4

close all; clear all; clc;

%% Load data and set parameters 
file000 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs000\fm\DFM_OUTPUT_FlowFM\FlowFM_map.nc';
file005 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs005_CInund_3000\fm\DFM_OUTPUT_FlowFM\FlowFM_map.nc';
file010 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs010\fm\DFM_OUTPUT_FlowFM_02\FlowFM_map.nc';
file015 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs015\fm\DFM_OUTPUT_FlowFM\FlowFM_map.nc';
file010_SSC25 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs010_SSC25\fm\DFM_OUTPUT_FlowFM\FlowFM_map.nc';
file010_SSC50 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs010_SSC50\fm\DFM_OUTPUT_FlowFM\FlowFM_map.nc';
file010_SSC50_pt1 = 'P:\11202744-008-vegetation-modelling\test_cases\saltmarsh_model\tests\tst_EQProfileWS2_Nested_Constant1_FricWav_0.038_NAVegPar_Hs010_SSC50\fm\DFM_OUTPUT_FlowFM_RUN01\FlowFM_map.nc'
M = 200;
N = 500;
cellsize = 5;

dat.x{1} = ncread(file000,'mesh2d_face_x');
dat.x{2} = ncread(file005,'mesh2d_face_x');
dat.x{3} = ncread(file010,'mesh2d_face_x');
dat.x{4} = ncread(file015,'mesh2d_face_x');
dat.x{5} = ncread(file010_SSC25,'mesh2d_face_x');
dat.x{6} = ncread(file010_SSC50,'mesh2d_face_x');
dat.y{1} = ncread(file000,'mesh2d_face_y');
dat.y{2} = ncread(file005,'mesh2d_face_y');
dat.y{3} = ncread(file010,'mesh2d_face_y');
dat.y{4} = ncread(file015,'mesh2d_face_y');
dat.y{5} = ncread(file010_SSC25,'mesh2d_face_y');
dat.y{6} = ncread(file010_SSC50,'mesh2d_face_y');
dat.bl_day{1} = ncread(file000,'mesh2d_mor_bl',[1,4321],[inf,inf]);
dat.bl_day{2} = ncread(file005,'mesh2d_mor_bl',[1,4321],[inf,inf]);
dat.bl_day{3} = ncread(file010,'mesh2d_mor_bl',[1,4321],[inf,inf]);
dat.bl_day{4} = ncread(file015,'mesh2d_mor_bl',[1,4321],[inf,inf]);
dat.bl_day{5} = ncread(file010_SSC25,'mesh2d_mor_bl',[1,4321],[inf,inf]);
dat.bl_day{6} = ncread(file010_SSC50,'mesh2d_mor_bl',[1,1681],[inf,inf]);

dat10.bl_day{1} = ncread(file000,'mesh2d_mor_bl',[1,864],[inf,1]);
dat10.bl_day{2} = ncread(file005,'mesh2d_mor_bl',[1,864],[inf,1]);
dat10.bl_day{3} = ncread(file010,'mesh2d_mor_bl',[1,864],[inf,1]);
dat10.bl_day{4} = ncread(file015,'mesh2d_mor_bl',[1,864],[inf,1]);
dat10.bl_day{5} = ncread(file010_SSC25,'mesh2d_mor_bl',[1,864],[inf,1]);
dat10.bl_day{6} = ncread(file010_SSC50_pt1,'mesh2d_mor_bl',[1,864],[inf,1]);

dat.start.blini = ncread(file000,'mesh2d_mor_bl',[1,1],[inf,1]);
veg_edge = [700,473,1350,2276,1208,1093];

%% Sort data
for i = 1:6
    [dat.y_Val_sort{i},dat.I_sort{i}] = sort(dat.y{i});
    dat.bl_sorted{i}     = dat.bl_day{i}(dat.I_sort{i});
    dat.bl_matrix{i}     = reshape(dat.bl_sorted{i},[M,N]);  % reshape to matrix
	[~,dat.bl.ind_max{i}]      = max(diff(dat.bl_matrix{i}')); % find marsh edge
	dat.bl_longshoremean(1:500,i) = mean(dat.bl_matrix{1,i});
    dat.bl_longshorestd(1:500,i)    = std(dat.bl_matrix{1,i});
    
    dat10.bl_sorted{i}     = dat10.bl_day{i}(dat.I_sort{i});
    dat10.bl_matrix{i}     = reshape(dat10.bl_sorted{i},[M,N]);  % reshape to matrix
	[~,dat10.bl.ind_max{i}]      = max(diff(dat10.bl_matrix{i}')); % find marsh edge
	dat10.bl_longshoremean(1:500,i) = mean(dat10.bl_matrix{1,i});
    dat10.bl_longshorestd(1:500,i)    = std(dat10.bl_matrix{1,i});


end 

[dat.start.y_Val_sort,dat.start.I_sort] = sort(dat.y{1});
dat.start.bl_sorted     = dat.start.blini(dat.start.I_sort);
dat.start.bl_matrix     = reshape(dat.start.bl_sorted,[M,N]);  % reshape to matrix
[~,dat.start.bl.ind_max]      = max(diff(dat.start.bl_matrix')); % find marsh edge
dat.start.bl_longshoremean(1:500) = mean(dat.start.bl_matrix);
dat.start.bl_longshorestd(1:500)    = std(dat.start.bl_matrix);

veg_edge_i = round(veg_edge/5);
X_arr = [0:5:2495];

%% Plot Figure
F = figure;
cmap = viridis(4);
XT = 100:200:2500;
XL = fliplr(XT)-100;

subplot('Position',[0.1 0.1 0.8 0.43])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);

for i = 5
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(3,:)-[0.2,0.4,0.25],0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',4);
end

for i = 6
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(3,:)-[0,0.5,0.3],0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',4);
end

for i = 2:4
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
end


text(1700,1.5,'H_s=0.05m','rotation',7)
text(1700,-0.3,'H_s=0.10m','rotation',13)
text(1950,-1.7,'H_s=0.15m','rotation',0)
text(350,2.5,'b.')
xlabel('cross-shore distance (m)');
ylabel('elevation (m+msl)');
set(gca,'xtick',XT,'xticklabels',XL)
ylim([-4,3]); xlim([275,2500]); grid on; box on; 

subplot('Position',[0.1,0.56,0.8,0.43])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);
for i = 1
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
end

P3L = plot(X_arr+100000,dat.bl_longshoremean(:,i),'color',[0,0,0],'linewidth',2);
P31L = plot(X_arr+100000,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[0,0,0],'linewidth',1);
P32L = plot(X_arr+100000,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[0,0,0],'linewidth',1);
P4L = plot(X_arr(veg_edge_i(i):end)+100000,dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[0,0,0],'linewidth',4);

text(1500,1.4,'H_s=0.00m','rotation',5)
text(350,2.5,'a.')
ylabel('elevation (m+msl)');
set(findall(gcf,'-property','FontSize'),'FontSize',11)
P3{7} = plot(X_arr-1000000,dat.bl_longshoremean(:,3),'color',[cmap(3,:),0.5],'linewidth',2);
legend([P2,P3L,P4L,P31L,P3{1},P3{2},P3{3},P3{4},P3{7},P3{5},P3{6}],{'initial','tidal flat','salt marsh',...
    'std','H_s=0.00m',...
    'H_s=0.05m','H_s=0.10m',...
    'H_s=0.15m','SSC=10mg/L','SSC=25mg/L','SSC=50mg/L'},'location','southeast',...
    'NumColumns',3,'Fontsize',9);
set(gca,'xtick',XT,'xticklabels',[])
ylim([-4,3]); xlim([275,2500]); grid on; box on; 

%print(F,'TEnd_Profiles','-dpng','-r300')

%% Plot Figure 2
F2 = figure;
cmap = viridis(4);
XT = 100:200:2500;
XL = fliplr(XT)-100;

subplot('Position',[0.1 0.1 0.8 0.20])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);

for i = 4
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(i,:),0.5],'linewidth',2)
end

text(350,2.2,'d. H_s=0.15m')
xlabel('cross-shore distance (m)');
% ylabel('elevation (m+msl)');
set(gca,'xtick',XT,'xticklabels',XL)
ylim([-4,3]); xlim([275,2500]); grid on; box on; 

subplot('Position',[0.1 0.33 0.8 0.20])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);

for i = 5
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(3,:)-[0.2,0.4,0.25],0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(3,:)-[0.2,0.4,0.25]],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(3,:)-[0.2,0.4,0.25],0.5],'linewidth',2)
end

for i = 6
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(3,:)-[0,0.5,0.3],0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(3,:)-[0,0.5,0.3]],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(3,:)-[0,0.5,0.3],1],'linewidth',2)
end

for i = 3
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(i,:),1],'linewidth',2)
end

text(350,2.2,'c. H_s=0.10m')
% xlabel('cross-shore distance (m)');
L1 = legend([P3{3},P3{5},P3{6}],{'SSC=10mg/L','SSC=25mg/L','SSC=50mg/L'},...
    'Fontsize',9,'orientation','horizontal','location','south')
ylabel('                          elevation (m+msl)');
set(gca,'xtick',XT,'xticklabels',[])
ylim([-4,3]); xlim([275,2500]); grid on; box on; 



subplot('Position',[0.1 0.56 0.8 0.20])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);

for i = 2%:4
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(i,:),1],'linewidth',2)
end


%text(1700,1.5,'H_s=0.05m','rotation',7)
%text(1700,-0.3,'H_s=0.10m','rotation',13)
%text(1950,-1.7,'H_s=0.15m','rotation',0)
text(350,2.2,'b. H_s=0.05m')
%xlabel('cross-shore distance (m)');
% ylabel('elevation (m+msl)');
set(gca,'xtick',XT,'xticklabels',[])
ylim([-4,3]); xlim([275,2500]); grid on; box on; 

subplot('Position',[0.1,0.79,0.8,0.2])
P1 = fill([0:5:2495,2500],[dat.start.bl_longshoremean,dat.start.bl_longshoremean(1)],[0.75,0.75,0.75]);
set(P1,'facealpha',0.3,'edgecolor','none');
hold on
P2 = plot(X_arr,dat.start.bl_longshoremean,'color',[0.5,0.5,0.5,0.5],'linewidth',2);
for i = 1
    P3{i} = plot(X_arr,dat.bl_longshoremean(:,i),'color',[cmap(i,:),0.5],'linewidth',2);
    P31{i} = plot(X_arr,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P32{i} = plot(X_arr,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[cmap(i,:)],'linewidth',1);
    P4{i} = plot(X_arr(veg_edge_i(i):end),dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[cmap(i,:)],'linewidth',4);
    P10{i} = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[cmap(i,:),1],'linewidth',2)
end

P3L = plot(X_arr+100000,dat.bl_longshoremean(:,i),'color',[0,0,0],'linewidth',2);
P31L = plot(X_arr+100000,dat.bl_longshoremean(:,i)-dat.bl_longshorestd(:,i),':','color',[0,0,0],'linewidth',1);
P32L = plot(X_arr+100000,dat.bl_longshoremean(:,i)+dat.bl_longshorestd(:,i),':','color',[0,0,0],'linewidth',1);
P4L = plot(X_arr(veg_edge_i(i):end)+100000,dat.bl_longshoremean(veg_edge_i(i):end,i),'color',[0,0,0],'linewidth',4);
P10L = plot(X_arr,dat10.bl_longshoremean(:,i),'--','color',[0,0,0],'linewidth',2)

%text(1500,1.4,'H_s=0.00m','rotation',5)
text(350,2.2,'a. H_s=0.00m')
% ylabel('elevation (m+msl)');
set(findall(gcf,'-property','FontSize'),'FontSize',11)
P3{7} = plot(X_arr-1000000,dat.bl_longshoremean(:,3),'color',[cmap(3,:),0.5],'linewidth',2);
legend([P2,P10L,P3L,P4L,P31L],{'initial','10 year','tidal flat','salt marsh',...
    'std'},'location','southeast',...
    'NumColumns',1,'Fontsize',9,'NumColumns',2);
L1.FontSize = 9;
set(gca,'xtick',XT,'xticklabels',[])
ylim([-4,3]); xlim([275,2500]); grid on; box on; 

print(F2,'TEnd_Profiles_v2','-dpng','-r300')
